/*
 * Copyright 2020 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*! @name PORTA10 (coord M9), SW3
  @{ */
#define BOOT_PIN_SW3_GPIO GPIOA /*!<@brief GPIO device name: GPIOA */
#define BOOT_PIN_SW3_PORT PORTA /*!<@brief PORT device name: PORTA */
#define BOOT_PIN_SW3_PIN 10U    /*!<@brief PORTA pin index: 10 */
                                /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitBootPin(void);

/*! @name PORTB16 (coord E10), U7[4]/UART0_RX
  @{ */
#define UART0_POLLFORACTIVITY_RX_GPIO_GPIO GPIOB /*!<@brief GPIO device name: GPIOB */
#define UART0_POLLFORACTIVITY_RX_GPIO_PORT PORTB /*!<@brief PORT device name: PORTB */
#define UART0_POLLFORACTIVITY_RX_GPIO_PIN 16U    /*!<@brief PORTB pin index: 16 */
                                                 /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void UART0_PollForActivity(void);

#define SOPT5_UART0TXSRC_UART_TX 0x00u /*!<@brief UART 0 transmit data source select: UART0_TX pin */

/*! @name PORTB16 (coord E10), U7[4]/UART0_RX
  @{ */
#define UART0_RX_PORT PORTB /*!<@brief PORT device name: PORTB */
#define UART0_RX_PIN 16U    /*!<@brief PORTB pin index: 16 */
                            /* @} */

/*! @name PORTB17 (coord E9), U10[1]/UART0_TX
  @{ */
#define UART0_TX_PORT PORTB /*!<@brief PORT device name: PORTB */
#define UART0_TX_PIN 17U    /*!<@brief PORTB pin index: 17 */
                            /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void UART0_InitPins(void);

/*! @name PORTB16 (coord E10), U7[4]/UART0_RX
  @{ */
#define UART0_RESTOREDEFAULT_RX_PORT PORTB /*!<@brief PORT device name: PORTB */
#define UART0_RESTOREDEFAULT_RX_PIN 16U    /*!<@brief PORTB pin index: 16 */
                                           /* @} */

/*! @name PORTB17 (coord E9), U10[1]/UART0_TX
  @{ */
#define UART0_RESTOREDEFAULT_TX_PORT PORTB /*!<@brief PORT device name: PORTB */
#define UART0_RESTOREDEFAULT_TX_PIN 17U    /*!<@brief PORTB pin index: 17 */
                                           /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void UART0_RestoreDefault(void);

/*! @name PORTC10 (coord C7), J2[20]/U20[D8]/I2C1_SCL/DA7212_CLK
  @{ */
#define I2C1_SCL_PORT PORTC /*!<@brief PORT device name: PORTC */
#define I2C1_SCL_PIN 10U    /*!<@brief PORTC pin index: 10 */
                            /* @} */

/*! @name PORTC11 (coord B7), J2[18]/U20[C9]/I2C1_SDA/DA7212_SDA
  @{ */
#define I2C1_SDA_PORT PORTC /*!<@brief PORT device name: PORTC */
#define I2C1_SDA_PIN 11U    /*!<@brief PORTC pin index: 11 */
                            /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void I2C1_InitPins(void);

/*! @name PORTC10 (coord C7), J2[20]/U20[D8]/I2C1_SCL/DA7212_CLK
  @{ */
#define I2C1_RESTOREDEFAULT_SCL_PORT PORTC /*!<@brief PORT device name: PORTC */
#define I2C1_RESTOREDEFAULT_SCL_PIN 10U    /*!<@brief PORTC pin index: 10 */
                                           /* @} */

/*! @name PORTC11 (coord B7), J2[18]/U20[C9]/I2C1_SDA/DA7212_SDA
  @{ */
#define I2C1_RESTOREDEFAULT_SDA_PORT PORTC /*!<@brief PORT device name: PORTC */
#define I2C1_RESTOREDEFAULT_SDA_PIN 11U    /*!<@brief PORTC pin index: 11 */
                                           /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void I2C1_RestoreDefault(void);

/*! @name PORTD0 (coord A5), J2[6]/SPI0_PCS0/FTM3_CH0
  @{ */
#define SPI0_PCS_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_PCS_PIN 0U     /*!<@brief PORTD pin index: 0 */
                            /* @} */

/*! @name PORTD1 (coord D4), J2[12]/SPI0_SCK/FB_CS0_B
  @{ */
#define SPI0_SCK_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_SCK_PIN 1U     /*!<@brief PORTD pin index: 1 */
                            /* @} */

/*! @name PORTD2 (coord C4), J2[8]/SPI0_SOUT/FB_AD4
  @{ */
#define SPI0_SOUT_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_SOUT_PIN 2U     /*!<@brief PORTD pin index: 2 */
                             /* @} */

/*! @name PORTD3 (coord B4), J2[10]/SPI0_SIN/FB_AD3
  @{ */
#define SPI0_SIN_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_SIN_PIN 3U     /*!<@brief PORTD pin index: 3 */
                            /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void SPI0_InitPins(void);

/*! @name PORTD0 (coord A5), J2[6]/SPI0_PCS0/FTM3_CH0
  @{ */
#define SPI0_RESTOREDEFAULT_PCS_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_RESTOREDEFAULT_PCS_PIN 0U     /*!<@brief PORTD pin index: 0 */
                                           /* @} */

/*! @name PORTD1 (coord D4), J2[12]/SPI0_SCK/FB_CS0_B
  @{ */
#define SPI0_RESTOREDEFAULT_SCK_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_RESTOREDEFAULT_SCK_PIN 1U     /*!<@brief PORTD pin index: 1 */
                                           /* @} */

/*! @name PORTD2 (coord C4), J2[8]/SPI0_SOUT/FB_AD4
  @{ */
#define SPI0_RESTOREDEFAULT_SOUT_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_RESTOREDEFAULT_SOUT_PIN 2U     /*!<@brief PORTD pin index: 2 */
                                            /* @} */

/*! @name PORTD3 (coord B4), J2[10]/SPI0_SIN/FB_AD3
  @{ */
#define SPI0_RESTOREDEFAULT_SIN_PORT PORTD /*!<@brief PORT device name: PORTD */
#define SPI0_RESTOREDEFAULT_SIN_PIN 3U     /*!<@brief PORTD pin index: 3 */
                                           /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void SPI0_RestoreDefault(void);

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
